package main

import (
	"fmt"
	"time"
)

//             12345678
const Niter = 1000000

const BufSize = 64*1024
var buf  [BufSize]byte
var buf2 [BufSize]byte

func main() {
	for size := 0; size <= BufSize; {
		src := buf[:size]
		dst := buf2[:size]

		// warmup
		copy(dst, src)

		Tstart := time.Now()

		niter := Niter
		if (size > 10000) {
			niter /= (size / 10000)
		}

		//for i := 0; i < Niter; i++ {
		for i := 0; i < niter; i++ {
			copy(dst, src)
		}

		Tend := time.Now()

		fmt.Printf("%v\t%.1f\n", size, float64(Tend.Sub(Tstart).Nanoseconds()) / float64(niter))

		size += 128

		//switch {
		//case size < 4*1024:
		//	size += 128	// detailed start
		//case size < 32*1024:
		//	size += 256
		//default:
		//	size += 512
		//}
	}
}
